list_policies¶
Operation¶
list_policies
async
¶
list_policies(request: ListPoliciesInput | ListPoliciesInputDict, /, *, plugins: list[Plugin] | None = None) -> ListPoliciesOutput
list_policies(*, plugins: list[Plugin] | None = None, **kwargs: Unpack[ListPoliciesInputDict]) -> ListPoliciesOutput
Lists all the managed policies that are available in your Amazon Web Services account, including your own customer-defined managed policies and all Amazon Web Services managed policies.
You can filter the list of policies that is returned using the optional
OnlyAttached, Scope, and PathPrefix parameters. For example, to
list only the customer managed policies in your Amazon Web Services
account, set Scope to Local. To list only Amazon Web Services
managed policies, set Scope to AWS.
You can paginate the results using the MaxItems and Marker
parameters.
For more information about managed policies, see Managed policies and inline policies in the IAM User Guide.
Note
IAM resource-listing operations return a subset of the available attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a customer manged policy, see GetPolicy.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
plugins
|
list[Plugin] | None
|
A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations. |
None
|
Returns:
| Type | Description |
|---|---|
ListPoliciesOutput
|
An instance of |
Input¶
Pass the input fields as keyword arguments, or pass a model or dictionary as the first positional argument. Pass plugins separately as a keyword argument.
Model¶
ListPoliciesInput
dataclass
¶
Bases: _SerdeShape
Dataclass for ListPoliciesInput structure.
Attributes¶
marker
class-attribute
instance-attribute
¶
marker: str | None = ...
Use this parameter only when paginating results and only after you
receive a response indicating that the results are truncated. Set it to
the value of the Marker element in the response that you received to
indicate where the next call should start.
max_items
class-attribute
instance-attribute
¶
max_items: int | None = ...
Use this only when paginating results to indicate the maximum number of
items you want in the response. If additional items exist beyond the
maximum you specify, the IsTruncated response element is true.
If you do not include this parameter, the number of items defaults to
100. Note that IAM might return fewer results, even when there are more
results available. In that case, the IsTruncated response element
returns true, and Marker contains a value to include in the
subsequent call that tells the service where to continue from.
only_attached
class-attribute
instance-attribute
¶
only_attached: bool = ...
A flag to filter the results to only the attached policies.
When OnlyAttached is true, the returned list contains only the
policies that are attached to an IAM user, group, or role. When
OnlyAttached is false, or when the parameter is not included, all
policies are returned.
path_prefix
class-attribute
instance-attribute
¶
path_prefix: str | None = ...
The path prefix for filtering the results. This parameter is optional.
If it is not included, it defaults to a slash (/), listing all policies.
This parameter allows (through its regex
pattern) a string of characters
consisting of either a forward slash (/) by itself or a string that must
begin and end with forward slashes. In addition, it can contain any
ASCII character from the ! (\u0021) through the DEL character
(\u007F), including most punctuation characters, digits, and upper and
lowercased letters.
policy_usage_filter
class-attribute
instance-attribute
¶
policy_usage_filter: str | None = ...
The policy usage method to use for filtering the results.
To list only permissions policies, set PolicyUsageFilter to
PermissionsPolicy. To list only the policies used to set permissions
boundaries, set the value to PermissionsBoundary.
This parameter is optional. If it is not included, all policies are returned.
scope
class-attribute
instance-attribute
¶
scope: str | None = ...
The scope to use for filtering the results.
To list only Amazon Web Services managed policies, set Scope to AWS.
To list only the customer managed policies in your Amazon Web Services
account, set Scope to Local.
This parameter is optional. If it is not included, or if it is set to
All, all policies are returned.
Dictionaries¶
ListPoliciesInputDict
¶
Bases: TypedDict
Dictionary form of ListPoliciesInput.
Attributes¶
marker
instance-attribute
¶
marker: str | None
Use this parameter only when paginating results and only after you
receive a response indicating that the results are truncated. Set it to
the value of the Marker element in the response that you received to
indicate where the next call should start.
max_items
instance-attribute
¶
max_items: int | None
Use this only when paginating results to indicate the maximum number of
items you want in the response. If additional items exist beyond the
maximum you specify, the IsTruncated response element is true.
If you do not include this parameter, the number of items defaults to
100. Note that IAM might return fewer results, even when there are more
results available. In that case, the IsTruncated response element
returns true, and Marker contains a value to include in the
subsequent call that tells the service where to continue from.
only_attached
instance-attribute
¶
only_attached: bool | None
A flag to filter the results to only the attached policies.
When OnlyAttached is true, the returned list contains only the
policies that are attached to an IAM user, group, or role. When
OnlyAttached is false, or when the parameter is not included, all
policies are returned.
path_prefix
instance-attribute
¶
path_prefix: str | None
The path prefix for filtering the results. This parameter is optional.
If it is not included, it defaults to a slash (/), listing all policies.
This parameter allows (through its regex
pattern) a string of characters
consisting of either a forward slash (/) by itself or a string that must
begin and end with forward slashes. In addition, it can contain any
ASCII character from the ! (\u0021) through the DEL character
(\u007F), including most punctuation characters, digits, and upper and
lowercased letters.
policy_usage_filter
instance-attribute
¶
policy_usage_filter: str | None
The policy usage method to use for filtering the results.
To list only permissions policies, set PolicyUsageFilter to
PermissionsPolicy. To list only the policies used to set permissions
boundaries, set the value to PermissionsBoundary.
This parameter is optional. If it is not included, all policies are returned.
scope
instance-attribute
¶
scope: str | None
The scope to use for filtering the results.
To list only Amazon Web Services managed policies, set Scope to AWS.
To list only the customer managed policies in your Amazon Web Services
account, set Scope to Local.
This parameter is optional. If it is not included, or if it is set to
All, all policies are returned.
Output¶
ListPoliciesOutput
dataclass
¶
Bases: _SerdeShape
Contains the response to a successful ListPolicies request.
Attributes¶
is_truncated
class-attribute
instance-attribute
¶
is_truncated: bool = ...
A flag that indicates whether there are more items to return. If your
results were truncated, you can make a subsequent pagination request
using the Marker request parameter to retrieve more items. Note that
IAM might return fewer than the MaxItems number of results even when
there are more results available. We recommend that you check
IsTruncated after every call to ensure that you receive all your
results.
marker
class-attribute
instance-attribute
¶
marker: str | None = ...
When IsTruncated is true, this element is present and contains the
value to use for the Marker parameter in a subsequent pagination
request.
policies
class-attribute
instance-attribute
¶
A list of policies.
response_metadata
class-attribute
instance-attribute
¶
Metadata about the response that produced this output. Use this to recover the request identifiers a service's support team needs in order to investigate a call. Members of the metadata are individually optional.